#include <bits/stdc++.h>
using namespace std;
const int mod=1e9+7;
typedef long long ll;
ll f(int a[],int l,int r,int k)
{
    ll ans=0;
    if(k==0)
    {
        for(int i=l;i<=r;++i)
        {
            ans=(ans+a[i])%mod;
        }
        return ans;
    }

    for(int i=l;i<=r;++i)
    {
        for(int j=i;j<=r;++j)
        {
            ans+=f(a,i,j,k-1);
        }
    }
    return ans;
}
int main()
{
    int n,k;
    cin>>n>>k;
    int a[n];
    for(int i=0;i<n;++i)
        cin>>a[i];
    cout<<f(a,0,n-1,k);
    return 0;
}